#ifndef _STACK_H_
#define _STACK_H_


#include "ENC28J60.h"
#include "TCP.h"
#include "ARP.h"
#include "UDP.h"
#include "ICMP.h"
#include "config.h"



Byte Checkmyip(void);
Byte Checkmymac(void);
extern void Ethernet_II_Header_erzeugen( Byte *buff);
extern void IP_Header_erzeugen(Byte *buff);

Word checksum (Byte * pointer,DWord result32,Word result16);

/*-------------------------------------------

	Main.C Zeugs
	

-------------------------------------------*/

/*Buffer Grsse*/
#define BUFFER_SIZE 600
extern Byte buffer[BUFFER_SIZE];

// volatile
//extern volatile Byte mymac[6];
//extern volatile Byte myip[4];
extern Byte mymac[6];
extern Byte myip[4];

#define Checkbroadcast() buffer[0] == 0xff && buffer[1] == 0xff && buffer[2] == 0xff && buffer[3] == 0xff && buffer[4] == 0xff && buffer[5] == 0xff


#define IP_TYPEFIELD 23
#define PORT_FIELD_L 37

#define TCP_PORT_L 37 // 0x25   Stelle im Header an der bei TCP der Port hinterlegt wird
#define TCP_PORT_H 36 // 0x24   Stelle im Header an der bei TCP der Port hinterlegt wird
#define HTTP_Port  80 // 0x50   Port fr HTTP (Hypertext Transfer Protocol)
#define FTP_Port   21 // 0x15   Port fr FTP  (File      Transfer Protocol)


/*-------------------------------------------

	STACK.C Structs

-------------------------------------------*/
#define ETH_HEADERLENGHT 14
#define IP_HEADERLENGHT 20

#define TYPE_TCP  0x06

struct ETH_Header	{
	Byte ETH_destMac[6];	
	Byte ETH_sourceMac[6];
	
};
struct IP_Header{
	Word IP_checksum;
	Byte IP_sourceIp[4];	
	Byte IP_destIp[4];
};

#endif
